﻿
(* This is an internal test of the exception handling for
   the DynamicsCont workflow which in its turn is implemented on
   top of continuations that add some difficulties. *)

open System

open Maritegra.Aivika
open Maritegra.Aivika.SD

module Test =

    let specs = {
    
        StartTime=0.0; StopTime=10000.0; DT=1.0; 
        Method=RungeKutta4; Randomness=SimpleRnd
    }
    
    type TestProcess (e) =
    
        inherit Process (e)
        
        override x.Activate = dynamicscont {
            printfn "before try"
            try
                try
                    printfn "inside try"
                    raise (new Exception ())
                    printfn "*** after exception ***"
                with
                | _ ->
                    printfn "exception handler"
            finally
                printfn "finally block"
            printfn "after try"
        }

    let env = Env ()
    
    let starter = (new TestProcess (env)).StartD (starttime)
    
    let system = dynamics {
    
        do! starter
        do! env.Run                           // launch the environment
    }
 
    [<EntryPoint>]   
    let main args =
        Dynamics.runLast system specs
        0
